/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, runOn, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs, delegateRemove, enumGetBox, delegateCombine } from "igniteui-react-core";
import { XInputGroup } from "./XInputGroup";
import { XLabel } from "./XLabel";
import { XInput } from "./XInput";
import { XSuffix } from "./XSuffix";
import { XIcon } from "./XIcon";
import { Popup } from "igniteui-react-core";
import { XCalendar } from "./XCalendar";
import { Rect } from "igniteui-react-core";
import { SRProvider } from "igniteui-react-core";
import { ControlDisplayDensity_$type } from "igniteui-react-core";
import { BaseControlTheme_$type } from "igniteui-react-core";
import { DayOfWeek_$type } from "./DayOfWeek";
import { FirstWeek_$type } from "./FirstWeek";
import { DateFormats_$type } from "./DateFormats";
import { BrushUtil } from "igniteui-react-core";
import { DateTimeValueFormatter } from "./DateTimeValueFormatter";
import { SelectedValueChangedEventArgs } from "./SelectedValueChangedEventArgs";
import { GotFocusEventArgs } from "./GotFocusEventArgs";
import { LostFocusEventArgs } from "./LostFocusEventArgs";
import { DatePickerVisualModelExport } from "./DatePickerVisualModelExport";
import { FontUtil } from "igniteui-react-core";
import { dateMinValue, dateMaxValue, dateGetDate, dateFromValues, dateGetMonth } from "igniteui-react-core";
import { stringContains, stringIsNullOrWhiteSpace, stringIsNullOrEmpty } from "igniteui-react-core";
import { stringSplit } from "igniteui-react-core";
import { isNaN_ } from "igniteui-react-core";
/**
 * @hidden
 */
export let DatePickerView = /*@__PURE__*/ (() => {
    class DatePickerView extends Base {
        constructor() {
            super();
            this.b = null;
            this.d = null;
            this.k = null;
            this.e = null;
            this.m = null;
            this.l = null;
            this.j = null;
            this.g = null;
            this.f = null;
            this.i = null;
            this.h = null;
            this.document_Click = this.document_Click.bind(this);
        }
        ah() {
        }
        get n() {
            return this.e;
        }
        ag(a) {
            if (a == null) {
                if (this.d != null) {
                    let b = this.d.rootWrapper.getChildAt(0);
                    b.unlistenAll();
                    document.removeEventListener("click", this.document_Click, false);
                }
                this.d = null;
                return;
            }
            this.d = a;
            let c = Math.round(a.rootWrapper.width());
            let d = Math.round(a.rootWrapper.height());
            this.aa();
            this.ab();
            let e = this.d.rootWrapper.getChildAt(0);
            e.listen("keydown", runOn(this, this.x));
            e.listen("focusin", runOn(this, this.v));
            e.listen("focusout", runOn(this, this.w));
            document.addEventListener("click", this.document_Click, false);
        }
        aa() {
            if (this.d != null) {
                this.k = this.d.rootWrapper.getChildAt(0);
                this.k.setAttribute("tabIndex", this.b.a7.toString());
                this.k.setStyleProperty("display", "flex");
                this.k.setStyleProperty("height", "100%");
                this.l = this.d.createElement("div");
                this.j = this.d.createElement("div");
                this.j.setRawStyleProperty("flex-grow", "1");
                this.g = this.d.createElement("div");
                this.g.setAttribute("aria-hidden", "true");
                this.f = this.d.createElement("div");
                this.g.setStyleProperty("padding-right", "2px");
                this.i = this.d.createElement("div");
                this.i.setAttribute("aria-hidden", "true");
                this.h = this.d.createElement("div");
                this.b.ch();
                this.j.getChildAt(0).setAttribute("aria-expanded", "fasle");
                this.j.getChildAt(0).setAttribute("aria-invalid", "false");
                this.f.setStyleProperty("height", "16px");
                this.f.setStyleProperty("width", "16px");
                this.h.setStyleProperty("height", "16px");
                this.h.setStyleProperty("width", "16px");
                this.f.listen("click", runOn(this, this.z));
                this.h.listen("click", runOn(this, this.ad));
            }
        }
        ak(a) {
            if (this.d != null) {
                let b = this.d.getSubRenderer(this.k);
                a.provideContainer(b);
                let c = b.getExternal(a, b.rootWrapper, this.d.getExternal(this.b, null, null));
            }
        }
        am(a) {
            if (this.d != null) {
                let b = this.d.getSubRenderer(this.l);
                a.provideContainer(b);
                let c = b.getExternal(a, b.rootWrapper, this.d.getExternal(this.b, null, null));
            }
        }
        al(a) {
            if (this.d != null) {
                let b = this.d.getSubRenderer(this.j);
                a.provideContainer(b);
                let c = b.getExternal(a, b.rootWrapper, this.d.getExternal(this.b, null, null));
            }
        }
        ao(a, b) {
            if (this.d != null) {
                let c = this.d.getSubRenderer(b);
                a.provideContainer(c);
                let d = c.getExternal(a, c.rootWrapper, this.d.getExternal(this.b, null, null));
            }
        }
        aj(a, b) {
            if (this.d != null) {
                let c = this.d.getSubRenderer(b);
                a.provideContainer(c);
                let d = c.getExternal(a, c.rootWrapper, this.d.getExternal(this.b, null, null));
            }
        }
        u() {
            return this.l;
        }
        t() {
            return this.j;
        }
        q() {
            return this.g;
        }
        p() {
            return this.f;
        }
        s() {
            return this.i;
        }
        r() {
            return this.h;
        }
        aq(a) {
            if (this.j != null) {
                if (a) {
                    this.j.getChildAt(0).setAttribute("aria-expanded", "true");
                }
                else {
                    this.j.getChildAt(0).setAttribute("aria-expanded", "false");
                }
            }
        }
        as(a) {
            if (a != null && a != "") {
                this.j.getChildAt(0).setAttribute("aria-label", a);
            }
            else {
                this.j.getChildAt(0).setAttribute("aria-label", "Select a date");
            }
        }
        ap() {
            if (this.f != null) {
                if (this.b.at == true) {
                    this.f.show();
                }
                else {
                    this.f.hide();
                }
            }
        }
        ae() {
            if (this.f != null) {
                this.f.hide();
            }
        }
        ar() {
            this.k.setAttribute("tabIndex", this.b.a7.toString());
        }
        ab() {
            if (this.d != null) {
                this.m = this.d.rootWrapper.getChildAt(1);
                this.e = this.d.createElement("div");
                this.e.setStyleProperty("width", "100%");
                this.e.setStyleProperty("height", "100%");
                this.e.setStyleProperty("display", "flex");
                this.b.ci();
                this.e.parent().setStyleProperty("height", "100%");
                if (this.b.av == true) {
                    this.e.parent().parent().setStyleProperty("max-width", "245px");
                }
                else {
                    this.e.parent().parent().setStyleProperty("max-width", "232px");
                }
                if (this.b.au == true) {
                    this.e.parent().parent().setStyleProperty("min-height", "270px");
                }
                else {
                    this.e.parent().parent().setStyleProperty("min-height", "234px");
                }
            }
        }
        y() {
            if (this.d != null) {
                if (this.b.av == true) {
                    this.e.parent().parent().setStyleProperty("max-width", "245px");
                }
                else {
                    this.e.parent().parent().setStyleProperty("max-width", "232px");
                }
                if (this.b.au == true) {
                    this.e.parent().parent().setStyleProperty("min-height", "270px");
                }
                else {
                    this.e.parent().parent().setStyleProperty("min-height", "234px");
                }
            }
        }
        an(a) {
            if (this.d != null) {
                let b = this.d.getSubRenderer(this.m);
                a.provideRenderer(b);
                let c = b.getExternal(a, b.rootWrapper, this.d.getExternal(this.b, null, null));
            }
        }
        ai(a) {
            if (this.d != null) {
                let b = this.d.getSubRenderer(this.e);
                a.provideContainer(b);
                let c = b.getExternal(a, b.rootWrapper, this.d.getExternal(this.b, null, null));
            }
        }
        o() {
            return this.e;
        }
        z(a) {
            if (this.b.ar == true) {
                return;
            }
            this.b.cf();
            if (this.f != null) {
                this.f.hide();
            }
        }
        ad(a) {
            a.stopPropagation();
            this.b.cn();
        }
        x(a) {
            let b = a.which;
            if (b == 27) {
                this.b.cg();
            }
        }
        v(a) {
            this.b.focus();
            let b = (a.originalEvent.relatedTarget);
            if (!this.c(b)) {
                this.b.ct();
            }
        }
        w(a) {
            let b = (a.originalEvent.relatedTarget);
            if (!this.c(b)) {
                this.b.cm();
                this.b.cu();
            }
        }
        document_Click(a) {
            let b = a.target;
            if (!this.c(b)) {
                this.b.cg();
            }
        }
        at() {
            if (this.d != null) {
                let a = this.d.rootWrapper.getNativeElement();
                let b = a.getBoundingClientRect();
                ;
                return b;
            }
            return null;
        }
        a() {
            let a = (window.innerWidth);
            let b = (window.innerHeight);
            let c = new Array(2);
            c[0] = a;
            c[1] = b;
            return c;
        }
        c(a) {
            if (null == a) {
                return false;
            }
            let b = this.j.getNativeElement();
            let c = this.e.getNativeElement();
            return b.contains(a) || c.contains(a);
        }
        af() {
        }
    }
    DatePickerView.$t = /*@__PURE__*/ markType(DatePickerView, 'DatePickerView');
    return DatePickerView;
})();
/**
 * @hidden
 */
export let DatePicker = /*@__PURE__*/ (() => {
    class DatePicker extends Base {
        constructor() {
            super();
            this.h = null;
            this.u = null;
            this.q = null;
            this.o = null;
            this.r = null;
            this.m = null;
            this.n = null;
            this.c = null;
            this.a9 = "dd";
            this.bd = "mm";
            this.bg = "yyyy";
            this.ba = "mdy";
            this.bf = "/";
            this.ah = false;
            this.ap = false;
            this.ao = false;
            this.ay = dateMinValue();
            this.ai = false;
            this.propertyChanged = null;
            this.selectedValueChanged = null;
            this.ae = null;
            this.a0 = dateMinValue();
            this.az = dateMinValue();
            this.bc = "";
            this.de = BrushUtil.g(255, 24, 29, 31);
            this.z = null;
            this.be = "";
            this.ax = dateMinValue();
            this.aw = dateMaxValue();
            this.x = 2;
            this.v = 1;
            this.aa = null;
            this.df = BrushUtil.g(255, 24, 29, 31);
            this.dd = BrushUtil.g(255, 163, 172, 184);
            this.al = true;
            this.am = false;
            this.ag = true;
            this.ak = true;
            this.i = 0;
            this.k = 0;
            this.an = false;
            this.a = new DateTimeValueFormatter();
            this.d = 0;
            this.bb = null;
            this.aj = false;
            this.a6 = 0;
            this.gotFocus = null;
            this.lostFocus = null;
            this.keyDown = null;
            this.changing = null;
            let a = new DatePickerView();
            a.b = this;
            this.h = a;
            this.h.ah();
            this.ce();
        }
        cz(a, b) {
            if (this.u != null) {
                this.ah = true;
                this.cg();
            }
            this.c8();
            if (this.selectedValueChanged != null) {
                this.selectedValueChanged(this, ((() => {
                    let $ret = new SelectedValueChangedEventArgs();
                    $ret.oldValue = a;
                    $ret.newValue = b;
                    return $ret;
                })()));
            }
            if (this.ai) {
                this.c3();
            }
        }
        notifySizeChanged() {
            this.h.af();
        }
        destroy() {
            if (this.c != null) {
                let a = this.c;
                a.selectedValueChanged = delegateRemove(a.selectedValueChanged, runOn(this, this.cd));
                let b = this.c;
                b.close = delegateRemove(b.close, runOn(this, this.cc));
            }
            this.provideContainer(null);
        }
        provideContainer(a) {
            this.h.ag(a);
        }
        setName(a) {
            this.o.e = a;
        }
        get af() {
            if (this.ae == null) {
                this.ae = new SRProvider(this.h.d);
                this.ae.cb("Calendar");
            }
            return this.ae;
        }
        get value() {
            return this.a0;
        }
        set value(a) {
            let b = this.a0;
            this.ay = b;
            this.a0 = a;
            if (+b != +(this.a0)) {
                this.cy("Value", b, this.a0);
            }
        }
        get a3() {
            return this.az;
        }
        set a3(a) {
            let b = this.az;
            this.az = a;
            if (+b != +(this.az)) {
                this.cy("Today", b, this.az);
            }
        }
        get bv() {
            return this.bc;
        }
        set bv(a) {
            let b = this.bc;
            this.bc = a;
            if (b != this.bc) {
                this.cy("Label", b, this.bc);
            }
        }
        get dh() {
            return this.de;
        }
        set dh(a) {
            let b = this.de;
            this.de = a;
            if (b != this.de) {
                this.cy("LabelTextColor", b, a);
            }
        }
        get ac() {
            return this.z;
        }
        set ac(a) {
            let b = this.z;
            this.z = a;
            if (b != this.z) {
                this.cy("LabelTextStyle", b, this.z);
            }
        }
        get b2() {
            return this.be;
        }
        set b2(a) {
            let b = this.be;
            this.be = a;
            if (b != this.be) {
                this.cy("Placeholder", b, this.be);
            }
        }
        get a2() {
            return this.ax;
        }
        set a2(a) {
            let b = this.ax;
            this.ax = a;
            if (+b != +(this.ax)) {
                this.cy("MinDate", b, this.ax);
            }
        }
        get a1() {
            return this.aw;
        }
        set a1(a) {
            let b = this.aw;
            this.aw = a;
            if (+b != +(this.aw)) {
                this.cy("MaxDate", b, this.aw);
            }
        }
        get y() {
            return this.x;
        }
        set y(a) {
            let b = this.x;
            this.x = a;
            if (b != this.x) {
                this.cy("Density", enumGetBox(ControlDisplayDensity_$type, b), enumGetBox(ControlDisplayDensity_$type, this.x));
            }
        }
        get w() {
            return this.v;
        }
        set w(a) {
            let b = this.v;
            this.v = a;
            if (b != this.v) {
                this.cy("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, this.v));
            }
        }
        get ad() {
            return this.aa;
        }
        set ad(a) {
            let b = this.aa;
            this.aa = a;
            if (b != this.aa) {
                this.cy("TextStyle", b, this.aa);
            }
        }
        get di() {
            return this.df;
        }
        set di(a) {
            let b = this.df;
            this.df = a;
            if (b != this.df) {
                this.cy("TextColor", b, this.df);
            }
        }
        get dg() {
            return this.dd;
        }
        set dg(a) {
            let b = this.dd;
            this.dd = a;
            if (b != this.dd) {
                this.cy("IconColor", b, this.dd);
            }
        }
        get at() {
            return this.al;
        }
        set at(a) {
            let b = this.al;
            this.al = a;
            if (b != this.al) {
                this.cy("ShowClearButton", b, this.al);
            }
        }
        get au() {
            return this.am;
        }
        set au(a) {
            let b = this.am;
            this.am = a;
            if (b != this.am) {
                this.cy("ShowTodayButton", b, this.am);
            }
        }
        get aq() {
            return this.ag;
        }
        set aq(a) {
            let b = this.ag;
            this.ag = a;
            if (b != this.ag) {
                this.cy("AllowTextInput", b, this.ag);
            }
        }
        get as() {
            return this.ak;
        }
        set as(a) {
            let b = this.ak;
            this.ak = a;
            if (b != this.ak) {
                this.cy("OpenOnFocus", b, this.ak);
            }
        }
        get j() {
            return this.i;
        }
        set j(a) {
            let b = this.i;
            this.i = a;
            if (b != this.i) {
                this.cy("FirstDayOfWeek", enumGetBox(DayOfWeek_$type, b), enumGetBox(DayOfWeek_$type, this.i));
            }
        }
        get l() {
            return this.k;
        }
        set l(a) {
            let b = this.k;
            this.k = a;
            if (b != this.k) {
                this.cy("FirstWeekOfYear", enumGetBox(FirstWeek_$type, b), enumGetBox(FirstWeek_$type, this.k));
            }
        }
        get av() {
            return this.an;
        }
        set av(a) {
            let b = this.an;
            this.an = a;
            if (b != this.an) {
                this.cy("ShowWeekNumbers", b, this.an);
            }
        }
        get e() {
            return this.d;
        }
        set e(a) {
            let b = this.d;
            this.d = a;
            if (this.d != b) {
                this.cy("DateFormat", enumGetBox(DateFormats_$type, b), enumGetBox(DateFormats_$type, this.d));
            }
        }
        get br() {
            return this.bb;
        }
        set br(a) {
            let b = this.bb;
            this.bb = a;
            if (b != this.bb) {
                this.cy("FormatString", b, this.bb);
            }
        }
        get ar() {
            return this.aj;
        }
        set ar(a) {
            let b = this.aj;
            this.aj = a;
            if (b != this.aj) {
                this.cy("IsDisabled", b, this.aj);
            }
        }
        get a7() {
            return this.a6;
        }
        set a7(a) {
            let b = this.a6;
            this.a6 = a;
            if (b != this.a6) {
                this.cy("TabIndex", b, this.a6);
            }
        }
        cy(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.c1(a, b, c);
        }
        c1(a, b, c) {
            switch (a) {
                case "Density":
                    this.c4();
                    break;
                case "BaseTheme":
                    this.c6();
                    break;
                case "Value":
                    if (+(this.value) != +(dateMinValue())) {
                        if (dateGetDate(this.value) < dateGetDate(this.a2) || dateGetDate(this.value) > dateGetDate(this.a1)) {
                            this.ai = true;
                            this.value = this.ay;
                            this.ai = false;
                        }
                    }
                    this.cz(this.ay, this.value);
                    this.ay = this.value;
                    if (this.c != null) {
                        this.c.value = this.value;
                    }
                    break;
                case "Label":
                    if (this.r != null) {
                        this.r.text = this.bv;
                        if (this.bv != null && this.bv != "") {
                            if (!this.q.inputs.contains(this.r)) {
                                this.q.inputs.insert(0, this.r);
                            }
                        }
                        else {
                            if (this.q.inputs.contains(this.r)) {
                                this.q.inputs.remove(this.r);
                            }
                        }
                    }
                    break;
                case "Placeholder":
                    if (this.o != null) {
                        this.o.cg = this.b2;
                        this.h.as(this.b2);
                    }
                    break;
                case "Today":
                    if (this.c != null) {
                        this.c.av = this.a3;
                    }
                    break;
                case "MaxDate":
                    if (this.c != null) {
                        let d = Base.compareSimple(this.a2, this.a1);
                        if (d >= 0) {
                            this.a1 = dateMaxValue();
                        }
                        this.c.at = this.aw;
                    }
                    if (dateGetDate(this.value) > dateGetDate(this.a1)) {
                        this.ay = dateMinValue();
                        this.ai = true;
                        this.value = dateMinValue();
                        this.ai = false;
                    }
                    break;
                case "MinDate":
                    if (this.c != null) {
                        this.c.au = this.ax;
                        let e = Base.compareSimple(this.a2, this.a1);
                        if (e >= 0) {
                            this.ay = dateMaxValue();
                            this.c.at = this.a1;
                        }
                    }
                    if (dateGetDate(this.value) < dateGetDate(this.a2)) {
                        this.ay = dateMinValue();
                        this.ai = true;
                        this.value = dateMinValue();
                        this.ai = false;
                    }
                    break;
                case "TextStyle":
                    this.c9();
                    break;
                case "ShowClearButton":
                    if (this.o != null) {
                        if (this.o.cq != "") {
                            this.h.ap();
                        }
                    }
                    break;
                case "LabelTextColor":
                case "LabelTextStyle":
                case "TextColor":
                case "IconColor":
                    this.da();
                    break;
                case "ShowTodayButton":
                    if (this.c != null) {
                        this.c.ae = this.au;
                        this.h.y();
                    }
                    break;
                case "AllowTextInput":
                    if (this.o != null) {
                        this.o.disabled = !this.aq;
                    }
                    break;
                case "OpenOnFocus": break;
                case "DateFormat":
                    this.a.k(this.e);
                    this.c8();
                    break;
                case "FormatString":
                    this.ce();
                    this.c8();
                    break;
                case "FirstDayOfWeek":
                    if (this.c != null) {
                        this.c.l = this.j;
                    }
                    break;
                case "ShowWeekNumbers":
                    if (this.c != null) {
                        this.c.af = this.av;
                        this.h.y();
                    }
                    break;
                case "FirstWeekOfYear":
                    if (this.c != null) {
                        this.c.o = this.l;
                    }
                    break;
                case "IsDisabled":
                    {
                        if (this.q != null) {
                            this.q.disabled = this.ar;
                        }
                        if (this.o != null) {
                            this.o.disabled = this.ar;
                        }
                    }
                    break;
                case "TabIndex":
                    this.h.ar();
                    break;
            }
        }
        ce() {
            let a = '/';
            let b = this.br != null ? this.br.toLowerCase() : this.a.j();
            if (stringContains(b, "/")) {
                a = '/';
            }
            else if (stringContains(b, "-")) {
                a = '-';
            }
            else if (stringContains(b, " ")) {
                a = ' ';
            }
            else if (stringContains(b, ".")) {
                a = '.';
            }
            else if (stringContains(b, ",")) {
                a = ',';
            }
            this.bf = a.toString();
            let c = b.split(a);
            if (c.length == 3) {
                let d = "";
                for (let e = 0; e < 3; e++) {
                    if (stringContains(c[e], "d")) {
                        d += "d";
                        switch (c[e]) {
                            case "d":
                                this.a9 = c[e];
                                break;
                            case "dd":
                                this.a9 = c[e];
                                break;
                            case "ddd":
                                this.a9 = c[e];
                                break;
                            case "dddd":
                                this.a9 = c[e];
                                break;
                            default:
                                this.a9 = "dd";
                                break;
                        }
                    }
                    else if (stringContains(c[e], "m")) {
                        d += "m";
                        switch (c[e]) {
                            case "m":
                                this.bd = c[e];
                                break;
                            case "mm":
                                this.bd = c[e];
                                break;
                            case "mmm":
                                this.bd = c[e];
                                break;
                            case "mmmm":
                                this.bd = c[e];
                                break;
                            default:
                                this.bd = "mm";
                                break;
                        }
                        this.bd = c[e];
                    }
                    else if (stringContains(c[e], "y")) {
                        d += "y";
                        switch (c[e]) {
                            case "yy":
                                this.bg = c[e];
                                break;
                            case "yyyy":
                                this.bg = c[e];
                                break;
                            default:
                                this.bg = "yyyy";
                                break;
                        }
                    }
                }
                if (d == "dmy" || d == "mdy" || d == "ymd") {
                    this.ba = d;
                }
                else {
                    this.ba = "mdy";
                }
            }
        }
        da() {
            if (this.o != null) {
                this.o.d8 = this.di;
            }
            if (this.m != null) {
                this.m.fill = this.dg;
            }
            if (this.n != null) {
                this.n.fill = this.dg;
            }
            if (this.r != null) {
                this.r.df = this.dh;
                this.r.y = this.ac;
            }
        }
        c7() {
            if (this.q != null) {
            }
        }
        c9() {
            if (this.aa != null) {
                this.o.af = this.aa;
            }
        }
        ch() {
            this.q = new XInputGroup();
            this.h.ak(this.q);
            this.q.d = 0;
            this.q.p = this.w;
            this.q.t = this.y;
            this.r = new XLabel();
            this.h.am(this.r);
            this.r.df = this.dh;
            this.r.y = this.ac;
            this.q.appendContentChild(this.h.u());
            if (this.bv != null && this.bv != "") {
                this.r.text = this.bv;
                this.q.inputs.add(this.r);
            }
            this.o = new XInput();
            this.h.al(this.o);
            this.o.b8 = "text";
            if (this.aa != null) {
                this.o.af = this.aa;
            }
            this.o.disabled = !this.aq;
            this.o.d8 = this.di;
            this.q.appendContentChild(this.h.t());
            this.q.inputs.add(this.o);
            this.o.cg = this.b2;
            this.h.as(this.b2);
            let a = this.o;
            a.change = delegateCombine(a.change, runOn(this, this.co));
            let b = this.o;
            b.changing = delegateCombine(b.changing, runOn(this, this.cp));
            let c = this.o;
            c.keyDown = delegateCombine(c.keyDown, runOn(this, this.cq));
            let d = new XSuffix();
            this.h.ao(d, this.h.q());
            this.m = new XIcon();
            this.h.aj(this.m, this.h.p());
            this.m.svgPath = DatePicker.bk;
            this.m.fill = this.dg;
            d.appendContentChild(this.h.p());
            this.q.appendContentChild(this.h.q());
            this.q.inputs.add(d);
            this.c8();
            let e = new XSuffix();
            this.h.ao(e, this.h.s());
            this.n = new XIcon();
            this.h.aj(this.n, this.h.r());
            this.n.svgPath = DatePicker.bj;
            this.n.fill = this.dg;
            e.appendContentChild(this.h.r());
            this.q.appendContentChild(this.h.s());
            this.q.inputs.add(e);
        }
        cq(a, b) {
            this.cw(b);
            if (b.defaultPrevented) {
                return;
            }
            let c = b.keyCode;
            let d = b.modifiers;
            switch (c) {
                case 9:
                    this.ao = true;
                    if (!this.ap) {
                        this.dc(this.o.cq);
                    }
                    this.ah = true;
                    this.cg();
                    this.ao = false;
                    break;
                case 13:
                    this.ao = true;
                    if (!this.ap) {
                        this.dc(this.o.cq);
                    }
                    this.ah = true;
                    this.cg();
                    this.ao = false;
                    break;
                case 40:
                    if (d == 1) {
                        this.c0();
                        this.cl();
                    }
                    break;
                case 38:
                    if (d == 1) {
                        this.cg();
                    }
                    break;
            }
        }
        cp(a, b) {
            this.cs(b);
            if (b.value.length > 0) {
                this.h.ap();
            }
            else {
                this.h.ae();
            }
        }
        co(a, b) {
            this.ap = true;
            this.dc(b.value);
            this.ap = false;
        }
        dc(a) {
            let b = ['/', '-', ' ', '.', ','];
            let c = stringSplit(a, b, 1);
            let d = 0;
            let e = 0;
            let f = 0;
            let g = true;
            if (c.length == 3) {
                if (c[0].length == 0 || c[1].length == 0 || c[2].length == 0) {
                    g = false;
                }
                if (this.ba == "dmy") {
                    d = parseInt(c[0]);
                    e = parseInt(c[1]);
                    f = parseInt(c[2]);
                }
                else if (this.ba == "mdy") {
                    e = parseInt(c[0]);
                    d = parseInt(c[1]);
                    f = parseInt(c[2]);
                }
                else if (this.ba == "ymd") {
                    f = parseInt(c[0]);
                    e = parseInt(c[1]);
                    d = parseInt(c[2]);
                }
                if (isNaN_(d) || isNaN_(f)) {
                    g = false;
                }
                if (f < 50) {
                    f = f + 2000;
                }
                if (isNaN_(e)) {
                    let h = "";
                    if (this.ba == "dmy") {
                        h = c[1].toLowerCase();
                    }
                    else if (this.ba == "mdy") {
                        h = c[0].toLowerCase();
                    }
                    else if (this.ba == "ymd") {
                        h = c[1].toLowerCase();
                    }
                    let i = !stringIsNullOrWhiteSpace(this.af.b1("January_Full")) ? this.af.b1("January_Full").toLowerCase() : "january";
                    let j = !stringIsNullOrWhiteSpace(this.af.b1("January_Short")) ? this.af.b1("January_Short").toLowerCase() : "jan";
                    let k = !stringIsNullOrWhiteSpace(this.af.b1("February_Full")) ? this.af.b1("February_Full").toLowerCase() : "february";
                    let l = !stringIsNullOrWhiteSpace(this.af.b1("February_Short")) ? this.af.b1("February_Short").toLowerCase() : "feb";
                    let m = !stringIsNullOrWhiteSpace(this.af.b1("March_Full")) ? this.af.b1("March_Full").toLowerCase() : "march";
                    let n = !stringIsNullOrWhiteSpace(this.af.b1("March_Short")) ? this.af.b1("March_Short").toLowerCase() : "mar";
                    let o = !stringIsNullOrWhiteSpace(this.af.b1("April_Full")) ? this.af.b1("April_Full").toLowerCase() : "april";
                    let p = !stringIsNullOrWhiteSpace(this.af.b1("April_Short")) ? this.af.b1("April_Short").toLowerCase() : "apr";
                    let q = !stringIsNullOrWhiteSpace(this.af.b1("May_Full")) ? this.af.b1("May_Full").toLowerCase() : "may";
                    let r = !stringIsNullOrWhiteSpace(this.af.b1("May_Short")) ? this.af.b1("May_Short").toLowerCase() : "may";
                    let s = !stringIsNullOrWhiteSpace(this.af.b1("June_Full")) ? this.af.b1("June_Full").toLowerCase() : "june";
                    let t = !stringIsNullOrWhiteSpace(this.af.b1("June_Short")) ? this.af.b1("June_Short").toLowerCase() : "jun";
                    let u = !stringIsNullOrWhiteSpace(this.af.b1("July_Full")) ? this.af.b1("July_Full").toLowerCase() : "july";
                    let v = !stringIsNullOrWhiteSpace(this.af.b1("July_Short")) ? this.af.b1("July_Short").toLowerCase() : "jul";
                    let w = !stringIsNullOrWhiteSpace(this.af.b1("August_Full")) ? this.af.b1("August_Full").toLowerCase() : "august";
                    let x = !stringIsNullOrWhiteSpace(this.af.b1("August_Short")) ? this.af.b1("August_Short").toLowerCase() : "aug";
                    let y = !stringIsNullOrWhiteSpace(this.af.b1("September_Full")) ? this.af.b1("September_Full").toLowerCase() : "september";
                    let z = !stringIsNullOrWhiteSpace(this.af.b1("September_Short")) ? this.af.b1("September_Short").toLowerCase() : "sep";
                    let aa = !stringIsNullOrWhiteSpace(this.af.b1("October_Full")) ? this.af.b1("October_Full").toLowerCase() : "october";
                    let ab = !stringIsNullOrWhiteSpace(this.af.b1("October_Short")) ? this.af.b1("October_Short").toLowerCase() : "oct";
                    let ac = !stringIsNullOrWhiteSpace(this.af.b1("November_Full")) ? this.af.b1("November_Full").toLowerCase() : "november";
                    let ad = !stringIsNullOrWhiteSpace(this.af.b1("November_Short")) ? this.af.b1("November_Short").toLowerCase() : "nov";
                    let ae = !stringIsNullOrWhiteSpace(this.af.b1("December_Full")) ? this.af.b1("December_Full").toLowerCase() : "december";
                    let af = !stringIsNullOrWhiteSpace(this.af.b1("December_Short")) ? this.af.b1("December_Short").toLowerCase() : "dec";
                    if (h == i || h == j) {
                        e = 1;
                    }
                    else if (h == k || h == l) {
                        e = 2;
                    }
                    else if (h == m || h == n) {
                        e = 3;
                    }
                    else if (h == o || h == p) {
                        e = 4;
                    }
                    else if (h == q || h == r) {
                        e = 5;
                    }
                    else if (h == s || h == t) {
                        e = 6;
                    }
                    else if (h == u || h == v) {
                        e = 7;
                    }
                    else if (h == w || h == x) {
                        e = 8;
                    }
                    else if (h == y || h == z) {
                        e = 9;
                    }
                    else if (h == aa || h == ab) {
                        e = 10;
                    }
                    else if (h == ac || h == ad) {
                        e = 11;
                    }
                    else if (h == ae || h == af) {
                        e = 12;
                    }
                    else {
                        g = false;
                    }
                }
                if (e > 12 || e < 1) {
                    g = false;
                }
            }
            else {
                g = false;
            }
            if (g) {
                let ag = dateFromValues(f, e, d, 0, 0, 0, 0);
                let ah = Base.compareSimple(ag, this.a2);
                let ai = Base.compareSimple(ag, this.a1);
                if (ah < 0 || ai > 0) {
                    this.c8();
                }
                else {
                    this.db(ag);
                    this.h.ap();
                }
            }
            else {
                if (stringIsNullOrEmpty(a)) {
                    this.cf();
                }
                else {
                    this.c8();
                }
            }
        }
        db(a) {
            let b = this.value;
            this.value = a;
        }
        c8() {
            if (this.o != null) {
                if (+(this.a0) != +(dateMinValue())) {
                    let a = "";
                    if (this.br == null) {
                        a = this.a.i(this.value);
                    }
                    else {
                        let b = this.value.getDate().toString();
                        let c = b;
                        if (this.a9 == "dd") {
                            if (this.value.getDate() < 10) {
                                b = "0" + b;
                            }
                        }
                        else if (this.a9 == "ddd") {
                            switch (this.value.getDay()) {
                                case 0:
                                    b = !stringIsNullOrWhiteSpace(this.af.b1("Sunday_Short")) ? this.af.b1("Sunday_Short") : "Sun";
                                    break;
                                case 1:
                                    b = !stringIsNullOrWhiteSpace(this.af.b1("Monday_Short")) ? this.af.b1("Monday_Short") : "Mon";
                                    break;
                                case 2:
                                    b = !stringIsNullOrWhiteSpace(this.af.b1("Tuesday_Short")) ? this.af.b1("Tuesday_Short") : "Tue";
                                    break;
                                case 3:
                                    b = !stringIsNullOrWhiteSpace(this.af.b1("Wednesday_Short")) ? this.af.b1("Wednesday_Short") : "Wed";
                                    break;
                                case 4:
                                    b = !stringIsNullOrWhiteSpace(this.af.b1("Thursday_Short")) ? this.af.b1("Thursday_Short") : "Thu";
                                    break;
                                case 5:
                                    b = !stringIsNullOrWhiteSpace(this.af.b1("Friday_Short")) ? this.af.b1("Friday_Short") : "Fri";
                                    break;
                                case 6:
                                    b = !stringIsNullOrWhiteSpace(this.af.b1("Saturday_Short")) ? this.af.b1("Saturday_Short") : "Sat";
                                    break;
                            }
                        }
                        else if (this.a9 == "dddd") {
                            switch (this.value.getDay()) {
                                case 0:
                                    b = !stringIsNullOrWhiteSpace(this.af.b1("Sunday_Full")) ? this.af.b1("Sunday_Full") : "Sunday";
                                    break;
                                case 1:
                                    b = !stringIsNullOrWhiteSpace(this.af.b1("Monday_Full")) ? this.af.b1("Monday_Full") : "Monday";
                                    break;
                                case 2:
                                    b = !stringIsNullOrWhiteSpace(this.af.b1("Tuesday_Full")) ? this.af.b1("Tuesday_Full") : "Tuesday";
                                    break;
                                case 3:
                                    b = !stringIsNullOrWhiteSpace(this.af.b1("Wednesday_Full")) ? this.af.b1("Wednesday_Full") : "Wednesday";
                                    break;
                                case 4:
                                    b = !stringIsNullOrWhiteSpace(this.af.b1("Thursday_Full")) ? this.af.b1("Thursday_Full") : "Thursday";
                                    break;
                                case 5:
                                    b = !stringIsNullOrWhiteSpace(this.af.b1("Friday_Full")) ? this.af.b1("Friday_Full") : "Friday";
                                    break;
                                case 6:
                                    b = !stringIsNullOrWhiteSpace(this.af.b1("Saturday_Full")) ? this.af.b1("Saturday_Full") : "Saturday";
                                    break;
                            }
                        }
                        let d = dateGetMonth(this.value).toString();
                        if (this.bd == "mm") {
                            if (dateGetMonth(this.value) < 10) {
                                d = "0" + d;
                            }
                        }
                        else if (this.bd == "mmm") {
                            switch (dateGetMonth(this.value)) {
                                case 1:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("January_Short")) ? this.af.b1("January_Short") : "Jan";
                                    break;
                                case 2:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("February_Short")) ? this.af.b1("February_Short") : "Feb";
                                    break;
                                case 3:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("March_Short")) ? this.af.b1("March_Short") : "Mar";
                                    break;
                                case 4:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("April_Short")) ? this.af.b1("April_Short") : "Apr";
                                    break;
                                case 5:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("May_Short")) ? this.af.b1("May_Short") : "May";
                                    break;
                                case 6:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("June_Short")) ? this.af.b1("June_Short") : "Jun";
                                    break;
                                case 7:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("July_Short")) ? this.af.b1("July_Short") : "Jul";
                                    break;
                                case 8:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("August_Short")) ? this.af.b1("August_Short") : "Aug";
                                    break;
                                case 9:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("September_Short")) ? this.af.b1("September_Short") : "Sep";
                                    break;
                                case 10:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("October_Short")) ? this.af.b1("October_Short") : "Oct";
                                    break;
                                case 11:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("November_Short")) ? this.af.b1("November_Short") : "Nov";
                                    break;
                                case 12:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("December_Short")) ? this.af.b1("December_Short") : "Dec";
                                    break;
                            }
                        }
                        else if (this.bd == "mmmm") {
                            switch (dateGetMonth(this.value)) {
                                case 1:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("January_Full")) ? this.af.b1("January_Full") : "January";
                                    break;
                                case 2:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("February_Full")) ? this.af.b1("February_Full") : "February";
                                    break;
                                case 3:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("March_Full")) ? this.af.b1("March_Full") : "March";
                                    break;
                                case 4:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("April_Full")) ? this.af.b1("April_Full") : "April";
                                    break;
                                case 5:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("May_Full")) ? this.af.b1("May_Full") : "May";
                                    break;
                                case 6:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("June_Full")) ? this.af.b1("June_Full") : "June";
                                    break;
                                case 7:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("July_Full")) ? this.af.b1("July_Full") : "July";
                                    break;
                                case 8:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("August_Full")) ? this.af.b1("August_Full") : "August";
                                    break;
                                case 9:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("September_Full")) ? this.af.b1("September_Full") : "September";
                                    break;
                                case 10:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("October_Full")) ? this.af.b1("October_Full") : "October";
                                    break;
                                case 11:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("November_Full")) ? this.af.b1("November_Full") : "November";
                                    break;
                                case 12:
                                    d = !stringIsNullOrWhiteSpace(this.af.b1("December_Full")) ? this.af.b1("December_Full") : "December";
                                    break;
                            }
                        }
                        let e = this.value.getFullYear().toString();
                        if (this.bg == "yy") {
                            e = e.substr(2);
                        }
                        if (this.ba == "dmy") {
                            if (this.a9 == "ddd" || this.a9 == "dddd") {
                                a = b + this.bf + d + " " + c + this.bf + e;
                            }
                            else {
                                a = b + this.bf + d + this.bf + e;
                            }
                        }
                        else if (this.ba == "mdy") {
                            if (this.a9 == "ddd" || this.a9 == "dddd") {
                                a = d + " " + c + this.bf + b + this.bf + e;
                            }
                            else {
                                a = d + this.bf + b + this.bf + e;
                            }
                        }
                        else if (this.ba == "ymd") {
                            if (this.a9 == "ddd" || this.a9 == "dddd") {
                                a = e + this.bf + d + " " + c + this.bf + b;
                            }
                            else {
                                a = e + this.bf + d + this.bf + b;
                            }
                        }
                    }
                    this.o.cq = a;
                    this.h.ap();
                }
                else {
                    this.o.cq = "";
                    this.h.ae();
                }
            }
        }
        cf() {
            if (this.ar == true) {
                return;
            }
            if (this.o != null) {
                this.o.cq = "";
            }
            this.value = dateMinValue();
            this.c.ch();
        }
        ci() {
            this.u = new Popup();
            this.h.an(this.u);
            this.c = new XCalendar();
            this.h.ai(this.c);
            if (+(this.a2) != +(dateMinValue())) {
                this.c.au = this.a2;
            }
            if (+(this.a1) != +(dateMaxValue())) {
                this.c.at = this.a1;
            }
            if (+(this.a3) != +(dateMinValue())) {
                this.c.av = this.a3;
            }
            this.c.ae = this.au;
            this.c.l = this.j;
            this.c.af = this.av;
            this.c.o = this.l;
            let a = this.c;
            a.selectedValueChanged = delegateCombine(a.selectedValueChanged, runOn(this, this.cd));
            let b = this.c;
            b.close = delegateCombine(b.close, runOn(this, this.cc));
            this.u.appendPopupContent(this.h.o());
        }
        cd(a, b) {
            this.ai = true;
            this.value = b.newValue;
            this.ai = false;
        }
        cc(a) {
            if (this.u.ao) {
                this.ah = true;
                this.cg();
            }
        }
        cn() {
            if (this.ah == false) {
                if (this.u.ao) {
                    this.cg();
                }
                else {
                    this.c0();
                }
            }
            else {
                this.ah = false;
            }
        }
        c0() {
            if (this.ar) {
                return;
            }
            if (this.u != null) {
                let a = this.h.at();
                let b = new Rect(0, a.left + window.pageXOffset, a.top + window.pageYOffset, a.width, a.height);
                let c = this.h.a()[1];
                let d = 240;
                if (this.au == true) {
                    d = 270;
                }
                let e = a.bottom + d;
                if (c < e) {
                    let f = a.top - d;
                    if (f < 0) {
                        this.u.showRelativeToExclusionRect(b, 1, 0);
                    }
                    else {
                        this.u.showRelativeToExclusionRect(b, 2, 0);
                    }
                }
                else {
                    this.u.showRelativeToExclusionRect(b, 1, 0);
                }
                this.h.aq(true);
            }
        }
        cg() {
            if (this.u != null) {
                window.setTimeout(() => this.u.bj(), 0);
            }
            if (this.c != null) {
                this.c.cy();
            }
            this.h.aq(false);
            this.ah = false;
        }
        focus(a = false) {
            if (this.o != null) {
                this.o.focus(a);
            }
            if (!this.u.ao && this.as == true) {
                if (this.ah == false) {
                    if (this.aq == false) {
                        this.c0();
                        this.ah = true;
                        window.setTimeout(() => this.cl(), 0);
                    }
                    else {
                        if (this.as == true && this.ao == false) {
                            this.c0();
                            this.ah = true;
                            window.setTimeout(() => this.cl(), 0);
                        }
                    }
                }
                else {
                    this.ah = false;
                }
            }
        }
        cm() {
            this.ah = false;
        }
        c3() {
            if (this.o != null) {
                this.o.dp();
            }
        }
        cl() {
            this.c.cq();
        }
        ct() {
            let a = new GotFocusEventArgs();
            this.cv(a);
        }
        cu() {
            let a = new LostFocusEventArgs();
            this.cx(a);
        }
        c6() {
        }
        c4() {
        }
        a8() {
            return this.b();
        }
        bo() {
            let a = this.b();
            return a.g();
        }
        b() {
            let a = new DatePickerVisualModelExport();
            a.e = this.y;
            a.d = this.w;
            a.c = this.u.ay();
            a.b = this.q.fe();
            a.a = this.c.bj();
            if (this.ad != null) {
                let b = this.ad;
                if (this.h != null && b.n == null) {
                    let c = this.h.d;
                    let d = FontUtil.getFontInfoFromString(c, b.fontString);
                    b.n = d.n;
                    b.d = d.d;
                    b.o = d.o;
                    b.q = d.q;
                    b.r = d.r;
                    b.s = d.s;
                }
                if (b.n != null) {
                    a.h = b.n;
                }
                if (!isNaN_(b.d)) {
                    a.f = b.d;
                }
                if (b.s != null) {
                    a.l = b.s;
                }
                if (b.q != null) {
                    a.j = b.q;
                }
                if (b.o != null) {
                    a.i = b.q;
                }
            }
            return a;
        }
        cv(a) {
            if (null != this.gotFocus) {
                this.gotFocus(this, a);
            }
        }
        cx(a) {
            if (null != this.lostFocus) {
                this.lostFocus(this, a);
            }
        }
        cw(a) {
            if (null != this.keyDown) {
                this.keyDown(this, a);
            }
        }
        cs(a) {
            if (null != this.changing) {
                this.changing(this, a);
            }
        }
    }
    DatePicker.$t = /*@__PURE__*/ markType(DatePicker, 'DatePicker', Base.$, [INotifyPropertyChanged_$type]);
    DatePicker.bj = "M20 3h-1V1h-2v2H7V1H5v2H4c-1.1 0-2 .9-2 2v16c0 1.1.9 2 2 2h16c1.1 0 2-.9 2-2V5c0-1.1-.9-2-2-2zm0 18H4V8h16v13z";
    DatePicker.bk = "M19 6.41L17.59 5 12 10.59 6.41 5 5 6.41 10.59 12 5 17.59 6.41 19 12 13.41 17.59 19 19 17.59 13.41 12z";
    DatePicker.ab = null;
    return DatePicker;
})();
